Program QuickSortDemo; 
{Wizualizacja algorytmu sortowania szybkiego}

{--------------------------------------}

Const n=140; 

Type Kolor=record 
             r,g,b: integer; 
           end; 
     Liczby=array[1..n] of integer; 
     Kolory=array[1..n] of Kolor; 
     
{--------------------------------------}     

Procedure Losuj(Var L: Liczby; Var K: Kolory); 

Var i: integer; 

Begin 
  For i:=1 to n do 
    Begin 
      L[i]:=1+random(350); 
      K[i].r:=random(255); 
      K[i].g:=random(255); 
      K[i].b:=random(255) 
    end 
end; {Losuj} 

{--------------------------------------}

Procedure Rysuj(i,x:integer; k:kolor); 

Begin 
  Pen(3,k.r,k.g,k.b); 
  MoveTo(0,3*i); 
  LineTo(x,3*i) 
end; {Rysuj}

{--------------------------------------}

Procedure Zamie(i,j: integer; Var L: Liczby; Var K: Kolory); 

Var pomx: integer; 
    pomk: Kolor; 

Begin 
  pomk.r:=255; pomk.g:=255; pomk.b:=255; 
  Rysuj(i,L[i],pomk); Rysuj(j,L[j],pomk); 
  pomx:=L[i]; L[i]:=L[j]; L[j]:=pomx; 
  pomk:=K[i]; K[i]:=K[j]; K[j]:=pomk; 
  Rysuj(i,L[i],K[i]); Rysuj(j,L[j],K[j]) 
end; {Zamie}

{--------------------------------------}

Procedure QuickSort(Var L: Liczby; Var K: Kolory; a,b: integer; przerwa: boolean);

Var i,j,m: integer;

Begin
  i:=a; j:=b; m:=L[(i+j) div 2];
  Repeat
    While L[i]<m do i:=i+1;
    While L[j]>m do j:=j-1;
    If i<=j then 
      Begin
        Zamie(i,j,L,K);
        i:=i+1;
        j:=j-1
      end
  until i>j;
  If przerwa then Delay(10);
  If a<j then QuickSort(L,K,a,j,przerwa);
  If i<b then QuickSort(L,K,i,b,przerwa) 
end; {QuickSort}

{--------------------------------------}

Var L: Liczby; 
    K: Kolory; 
    i,x,y: integer;
    przerwa: boolean; 

Begin
  Write('Spowolni? [T/N]'); 
  Repeat
    Event(i,x,y)
  until (i=1) and (y=2) and 
        ((x=78) or (x=110) or (x=84) or (x=116));
  przerwa:=(x=84) or (x=116);
  Clear; 
  Losuj(L,K); 
  For i:=1 to n do Rysuj(i,L[i],K[i]); 
  MoveTo(0,3*n); 
  WriteLn('Nacinij dowolny klawisz...'); 
  While not IsEvent do; 
  MoveTo(0,3*n); 
  WriteLn('                           '); 
  QuickSort(L,K,1,n,przerwa)
end.
