Program SitoEratostenesaDemo;
{Wizualizacja algorytmu sita Eratostenesa}

{---------------------------------------------------------}

Const n=200;

{---------------------------------------------------------}

Type TPierwsze = array [1..n] of boolean;

{---------------------------------------------------------}

Procedure Wypisz(P: TPierwsze);

Var i,j: integer;
    s: string;

Begin
  For i:=2 to n do
    Begin
      MoveTo(72*((i-2) mod 10),16*((i-2) div 10));
      If P[i] then TextColor(0, 0, 255)
      else TextColor(0,0,0);
      Write(i:8);
      If not P[i] then
        Begin
          Str(i,s); j:=Length(s); 
          Line(72-9*j+72*((i-2) mod 10),16*((i-2) div 10),
               72+72*((i-2) mod 10),16+16*((i-2) div 10));
          Line(72-9*j+72*((i-2) mod 10),16+16*((i-2) div 10),
               72+72*((i-2) mod 10),16*((i-2) div 10));
        end
    end
end; {Wypisz}

{---------------------------------------------------------}

Procedure Info(i: integer);

Var k,x,y: integer;

Begin
  MoveTo(0,400); TextColor(0,0,0);
  WriteLn('Bd skrela wielokrotnoci ',i,' poczynajc od ',i*i);
  WriteLn('Nacinij dowolny klawisz...');
  While not IsEvent do;
  Event(k,x,y)
end; {Info}

{---------------------------------------------------------}

Var Pierwsze: TPierwsze;  
    i,j: integer;

{=========================================================}

Begin  
  Pen(1,255,0,0);
  For i:=2 to n do Pierwsze[i]:=true;
  Wypisz(Pierwsze);
  Info(2);
  For i:=3 to n do Pierwsze[i]:=odd(i);
  Wypisz(Pierwsze); 
  i:=3;
  While i*i<=n do
    Begin
      Info(i);
      For j:=i to n div i do Pierwsze[i*j]:=false;
      Wypisz(Pierwsze);
      Repeat
        i:=i+2
      until Pierwsze[i]
    end;
  MoveTo(0,400);
  WriteLn(' ':80);
  WriteLn(' ':80)
end.
