Program SitoEratostenesaDemo;
{Wizualizacja algorytmu sita Eratostenesa}

{---------------------------------------------------------}

Const n=200;

{---------------------------------------------------------}

Type TPierwsze = array [1..n] of boolean;

{---------------------------------------------------------}

Procedure Wypisz(P: TPierwsze);

Var i,j: integer;
    s: string;

Begin
  For i:=1 to n do
    Begin
      MoveTo(72*((i-1) mod 10),16*((i-1) div 10));
      If P[i] then TextColor(0, 0, 255)
      else TextColor(0,0,0);
      Write(2*i+1:8);
      If not P[i] then
        Begin
          Str(2*i+1,s); j:=Length(s); 
          Line(72-9*j+72*((i-1) mod 10),16*((i-1) div 10),
               72+72*((i-1) mod 10),16+16*((i-1) div 10));
          Line(72-9*j+72*((i-1) mod 10),16+16*((i-1) div 10),
               72+72*((i-1) mod 10),16*((i-1) div 10));
        end
    end
end; {Wypisz}

{---------------------------------------------------------}

Procedure Info(i: integer);

Var k,x,y: integer;

Begin
  MoveTo(0,400); TextColor(0,0,0);
  WriteLn('Bd skrela wielokrotnoci ',i,' poczynajc od ',i*i);
  WriteLn('Nacinij dowolny klawisz...');
  While not IsEvent do;
  Event(k,x,y)
end; {Info}

{---------------------------------------------------------}

Var Pierwsze: TPierwsze;  
    i,j,d: integer;

{=========================================================}

Begin  
  Pen(1,255,0,0);
  For i:=1 to n do Pierwsze[i]:=true;
  Wypisz(Pierwsze); 
  i:=1; d:=3; j:=4;
  While j<=n do
    Begin
      Info(d);
      while j<=n do
        begin
          Pierwsze[j]:=false;
          j:=j+d
        end;
      Wypisz(Pierwsze);
      Repeat
        i:=i+1
      until Pierwsze[i];
      d:=2*i+1;
      j:=(d*d) div 2
    end;
  MoveTo(0,400);
  WriteLn(' ':80);
  WriteLn(' ':80)
end.
