Program WielokatZPrzekatnymi;

{----------------------------------------------------------}

Const max=100;

{----------------------------------------------------------}

Type Punkty=array [1..max,1..2] of integer;

{----------------------------------------------------------}
     
Procedure Wczytaj(Var n,r: integer);

Begin
  Repeat
    Write('n='); ReadLn(n)
  until (n>=3) and (n<=max);
  Repeat
    Write('r='); ReadLn(r)
  until r>0
end; {Wczytaj}

{----------------------------------------------------------}

Procedure ObliczWsp(Var T: Punkty; n,r: integer);

Var xs,ys,i: integer;
    alfa: real;

Begin
  xs:=r; ys:=r; alfa:=2*pi/n;
  For i:=1 to n do
    Begin
      T[i,1]:=xs+round(r*cos(i*alfa));
      T[i,2]:=ys+round(r*sin(i*alfa))
    end
end; {ObliczWsp}

{----------------------------------------------------------}

Procedure Rysuj(T: Punkty; n,r: integer);

Var i,j: integer;

Begin
  For i:=1 to n-1 do
    For j:=i+1 to n do
      Begin
        Pen(1,random(255),random(255),random(255));
        Line(T[i,1],T[i,2],T[j,1],T[j,2])
      end 
end; {Rysuj}

{----------------------------------------------------------}

Var T: Punkty;
    n,r: integer;

Begin 
  Randomize;
  Wczytaj(n,r);
  ObliczWsp(T,n,r);
  Rysuj(T,n,r)
end.
