Program Sortowania; 
const 
   MaxN = 10; 
type 
   Tablica = array [0..MaxN] of integer; 
var 
   A,B : Tablica; 
   i,n,m,q,od,z : integer; 
   Odp : char; 
procedure Wypelnij (var A : Tablica; n : integer); 
var 
   i : integer; 
begin 
  for i:=1 to n do 
    A[i]:=random(100) 
end; 
{Wypelnij} 
procedure SortujWybier (var A : Tablica; n : integer); 
var 
   M,i,j,k : integer; 
   x : integer; 
begin 
  for i:=1 to n-1 do 
    begin 
      k:=i; 
      x:=A[i]; 
      {(0) przyjmujemy pocz. el. za min.} 
      for j:=i+1 to n do 
        {(1a) znajdujemy minimum - x} 
        if A[j]<x then 
          begin 
            k:=j; 
            {(1b) i jego numer - k} 
            x:=A[j] 
          end; 
      {if} 
      {koniec wewn. petli for} 
      A[k]:=A[i]; 
      {(2a) przestawiamy pocz. el. na poz. k} 
      A[i]:=x; 
      writeln; 
      for m:=1 to n do 
        write(A[m]:4); 
      writeln; 
      {(2b) przestawiamy min. na poczatek} 
    end 
    {for} 
    {(3) i dalej - bez pierwszego el.} 
end; 
{SortujWybier} 
procedure SortujWstaw (var A : Tablica; n : integer); 
var 
   M,i,j : integer; 
   x : integer; 
begin 
  for i:=2 to n do 
    begin 
      x:=A[i]; 
      A[0]:=x; 
      j:=i-1; 
      while x<A[j] do 
        begin 
          A[j+1]:=A[j]; 
          j:=j-1 
        end; 
      {while} 
      A[j+1]:=x; 
      write('i=',i:2,' j=',j:2,' x=',x:2,'  '); 
      for m:=0 to n do 
        write(A[m]:4); 
      writeln; 
    end 
    {for} 
end; 
{SortujWstaw} 
procedure SortujWstawPol (var A : Tablica; n : integer); 
var 
   i,j,l,p,m : integer; 
   x : integer; 
begin 
  for i:=2 to n do 
    begin 
      x:=A[i]; 
      l:=1; 
      p:=i-1; 
      while l<=p do 
        begin 
          m:=(l+p) div 2; 
          if x<A[m] then 
            p:=m-1 
          else 
            l:=m+1 
        end; 
      {while} 
      for j:=i-1 downto l do 
        A[j+1]:=A[j]; 
      A[l]:=x 
    end 
    {for} 
end; 
{SortujWstawPol} 
procedure SortujQuick (var A : Tablica; l,p : integer); 
var 
   i,j : integer; 
   x,w : integer; 
begin 
  i:=l; 
  j:=p; 
  x:=A[(l+p) div 2]; 
  {(1)wybieramy srodkowy element - x} 
  repeat 
    while A[i]<x do 
      i:=i+1; 
    { z lewa - dopoki A[i] mniejsze to nast.} 
    while x<A[j] do 
      j:=j-1; 
    { z prawa - dopoki A[j] wieksze to nast.} 
    if i<=j then 
      begin 
        w:=A[i]; 
        {(2) jesli nie, to przenosimy...} 
        A[i]:=A[j]; 
        { element z lewa na...} 
        A[j]:=w; 
        { prawo..} 
        i:=i+1; 
        { i bierzemy nastepne} 
        j:=j-1 
        { z obu stron} 
      end 
      {if} 
  until (i>j); 
  if l<j then 
    SortujQuick(A,l,j); 
  {(3) dalej to samo z lewa strona} 
  if i<p then 
    SortujQuick(A,i,p) 
    {(4) i to samo z prawa strona} 
end; 
{SortujQuick} 
procedure SortujBabel (var A : Tablica; n : integer); 
var 
   i,j : integer; 
   x : integer; 
begin 
  for i:=2 to n do 
    {(2)a nastepnie to samo} 
    for j:=n downto i do 
      { ale bez pierwszego} 
      if A[j-1]>A[j] then 
        begin 
          {(1) od ostatniego, jesli...} 
          x:=A[j-1]; 
          { poprzedni wiekszy to...} 
          A[j-1]:=A[j]; 
          { ostatni zamieniamy z...} 
          A[j]:=x 
          { przedostatnim, itd...} 
        end 
        {if} 
        { do pierwszego;} 
end; 
{SortujBabel} 
PROCEDURE SortujScal(VAR A:Tablica; Lewy,Prawy:INTEGER); 
{od Sysly} 
VAR 
   Srodek:INTEGER; 
PROCEDURE Scal(VAR A:Tablica; Poczatek,Granica,Koniec:INTEGER); 
VAR 
   i,j,l:INTEGER; 
   B :Tablica; 
BEGIN 
  i:=Poczatek; 
  j:=Granica; 
  l:=Poczatek; 
  WHILE (i<Granica) AND (j<=Koniec) DO 
    BEGIN 
      IF A[i]<=A[j] THEN 
        BEGIN 
          B[l]:=A[i]; 
          i:=i+1 
        END 
      ELSE 
        BEGIN 
          B[l]:=A[j]; 
          j:=j+1 
        END; 
      l:=l+1 
    END; 
  WHILE i<Granica DO 
    BEGIN 
      {dolaczanie koncowki pierwszego podciagu} 
      B[l]:=A[i]; 
      l:=l+1; 
      i:=i+1 
    END; 
  WHILE j<=Koniec DO 
    BEGIN 
      {dolaczanie koncowki drugiego podciagu} 
      B[l]:=A[j]; 
      l:=l+1; 
      j:=j+1 
    END; 
  FOR i:=Poczatek TO Koniec DO 
    {kopiowanie wyniku z powrotem do tablicy A} 
    A[i]:=B[i] 
END; 
{Scal} 
BEGIN 
  IF Lewy<Prawy THEN 
    BEGIN 
      Srodek:=(Lewy+Prawy) DIV 2; 
      SortujScal(A, Lewy,Srodek); 
      SortujScal(A, Srodek+1,Prawy); 
      Scal(A, Lewy,Srodek+1,Prawy) 
    END 
END; 
{SortujScal} 
begin 
  {program} 
  repeat 
    writeln('   1 - sortowanie przez wybieranie proste'); 
    writeln('   2 - sortowanie przez wstawianie proste'); 
    writeln('   3 - sortowanie przez wstawianie proste polowkowe'); 
    writeln('   4 - sortowanie babelkowe'); 
    writeln('   5 - sortowanie szybkie (QuickSort)'); 
    writeln('   6 - sortowanie przez scalanie'); 
    write('Wybierz rodzaj sortowania: '); 
    readLn(odp); 
    writeln; 
    write('Podaj wymiar: max=',maxN,': '); 
    readln(n); 
    for i:=0 to 10 do 
      A[i]:=0; 
    Wypelnij(A,n); 
    WRITE('WYLOSOWANO:       '); 
    for m:=1 to n do 
      write(A[m]:4); 
    writeln; 
    B:=A; 
    case odp of 
      '1': 
        SortujWybier(B,n); 
      '2': 
        SortujWstaw(B,n); 
      '3': 
        SortujWstawPol(B,n); 
      '4': 
        SortujBabel(B,n); 
      '5': 
        SortujQuick(B,1,n); 
      '6': 
        SortujScal(B,1,n); 
    end 
    {case}; 
    writeln; 
    for m:=1 to n do 
      write(B[m]:4); 
    writeln; 
    writeln; 
    write('powtarzamy? (t/n)'); 
    writeln; 
    event(q,od,z); 
    odp:=chr(od); 
  until (odp='N') or (odp='n'); 
end.
